

#property indicator_chart_window

extern string UniqueID         = "Lines1";
extern double LinesStepPips    = 50;
extern int    LinesAbove       = 50;
extern int    LinesBellow      = 50;
extern color  LinesAboveColor  = LimeGreen;
extern color  LinesBellowColor = DeepSkyBlue;
extern color  LinesMiddleColor = Blue;
extern int    LinesMiddleWidth = 2;
extern int    LinesAboveWidth  = 0;
extern int    LinesBellowWidth = 0;
extern bool   LinesDrawnAsBack = false;
extern double StartingPrice    = 0;
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

int init()   { return(0); }
int deinit()
{
   string lookFor = UniqueID+":";
   for (int i= ObjectsTotal()-1; i>= 0; i--)
   {
      string name = ObjectName(i); if (StringFind(name,lookFor,0)==0) ObjectDelete(name);
   }
   return(0); 
}
double states[][4];
int start()
{
   int i; double step = LinesStepPips*_Point*MathPow(10,_Digits%2);
   
      if (StartingPrice==0) StartingPrice = Close[0];

      //
      //
      //
      //
      //

      int totalLines = ArrayRange(states,0); int currentLine = 0;
      createLine("middle",StartingPrice,LinesMiddleColor,LinesMiddleWidth,totalLines,currentLine);
         for (i = 0; i < LinesAbove;  i++) createLine("above"+i ,StartingPrice+(i+1)*step,LinesAboveColor ,LinesAboveWidth ,totalLines, currentLine);
         for (i = 0; i < LinesBellow; i++) createLine("bellow"+i,StartingPrice-(i+1)*step,LinesBellowColor,LinesBellowWidth,totalLines, currentLine);
      manageAlerts(totalLines);   
   return(0);
}
//--------------------------------------------------------------------
//
//--------------------------------------------------------------------
//
//
//
//
//

void createLine(string add, double price, color lineColor, int lineWidth, int& totalLines, int& currentLine)
{
   string name = UniqueID+":"+add;
   ObjectCreate(name,OBJ_HLINE,0,0,0);
      ObjectSet(name,OBJPROP_PRICE1,price);
      ObjectSet(name,OBJPROP_COLOR,lineColor);
      ObjectSet(name,OBJPROP_BACK,LinesDrawnAsBack);
      ObjectSet(name,OBJPROP_WIDTH,lineWidth);
      currentLine++; if (currentLine>ArrayRange(states,0)) 
                        { 
                           totalLines = currentLine;
                           ArrayResize(states,totalLines); 
                                       states[totalLines-1][0] = price;
                                       states[totalLines-1][1] = 0;
                                       states[totalLines-1][2] = 0;
                                       states[totalLines-1][3] = Time[0];
                        }
                        int bar = 1; if (alertsOnCurrent) bar = 0;
                           if (states[currentLine-1][0]<Close[1+bar]) states[currentLine-1][1] =  1;
                           if (states[currentLine-1][0]>Close[1+bar]) states[currentLine-1][1] = -1;
                           if (states[currentLine-1][0]<Close[0+bar]) states[currentLine-1][2] =  1;
                           if (states[currentLine-1][0]>Close[0+bar]) states[currentLine-1][2] = -1;
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts(int totalLines)
{
   if (alertsOn)
   {
      for (int i = 0; i<totalLines; i++)
         if (states[i][1]!=states[i][2])
         {
            if (states[i][2] == -1) doAlert(states[i][0],i,"down");
            if (states[i][2] ==  1) doAlert(states[i][0],i,"up");
         }         
   }
}

//
//
//
//
//

void doAlert(double price,int forLine, string doWhat)
{
   if (states[forLine][3] != Time[0]) {
       states[forLine][3]  = Time[0];

       //
       //
       //
       //
       //

       string message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," line "+DoubleToStr(price,_Digits)+" crossed : ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," lines "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}